function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import MenuItem from '@material-ui/core/MenuItem';
import TextField from '../TextField';
import { optionShape } from '../utils/PropTypes';

var SelectField = function SelectField(_ref) {
  var options = _ref.options,
      _ref$multiple = _ref.multiple,
      multiple = _ref$multiple === void 0 ? false : _ref$multiple,
      _ref$native = _ref.native,
      native = _ref$native === void 0 ? false : _ref$native,
      InputLabelProps = _ref.InputLabelProps,
      SelectProps = _ref.SelectProps,
      props = _objectWithoutProperties(_ref, ["options", "multiple", "native", "InputLabelProps", "SelectProps"]);

  var isNative = !multiple && native;
  return React.createElement(TextField, _extends({}, props, {
    InputLabelProps: _objectSpread({
      shrink: isNative === true ? true : undefined
    }, InputLabelProps),
    SelectProps: _objectSpread({}, SelectProps, {
      multiple: multiple,
      native: isNative
    }),
    select: true
  }), isNative ? options.map(function (option) {
    return React.createElement("option", {
      key: option.value,
      value: option.value
    }, option.label);
  }) : options.map(function (option) {
    return React.createElement(MenuItem, {
      key: option.value,
      value: option.value
    }, option.label);
  }));
};

if (process.env.NODE_ENV !== 'production') {
  SelectField.propTypes = {
    options: PropTypes.arrayOf(optionShape).isRequired,
    multiple: PropTypes.bool,
    native: PropTypes.bool,
    InputLabelProps: PropTypes.object,
    SelectProps: PropTypes.object
  };
}

export default SelectField;